var _mainStage = 'mainStage';
var _notificationStage = 'nofiticationStage';
var _appData = new AppDataCookie();
var _depotDB = new Depot();
var _plugin = null;
var _mojowhatsupPlugin = new MojowhatsupPluginModel();
var _appDB = new AppDatabase();
var _networkConnected = false;
var _mainAssistant = null;
var _openChatAssistant = null;
var _chatsAssistant = null;
var _appAssistant = null;
var _contactsAssistant = null;
var _mainStageController = null;
var _dashboardAssistant = null;
var _dashboardStageController = null;
var _groupAssistant = null;
var _prefsAssistant = null;
var _chatTextClipboard = new HashTable();
var _contactJidNames = new HashTable();
var _lastSoundGroupNotification = 0;
var _lastSoundPersonNotification = 0;
var _lastVibrateGroupNotification = 0;
var _lastVibratePersonNotification = 0;
var _MINIMUM_NOTIFICATION_INTERVAL = 2000;
var _SYNC_INTERVAL = 7200000;
var _CHECK_UPDATES_INTERVAL = 43200000;
var _contactsImported = false;
var _exitApp = false;
var _myJid = null;
var _statusRequest = null;
var _mojoWhatsupService = new MojoWhatsupService();
var _broadcastAssistant = null;
var _blocklistAssistant = null;

function AppAssistant(){
}

AppAssistant.prototype.setup = function(){
    Mojo.Log.info("******** INTO AppAssistant SETUP");
    _appAssistant = this;
}

AppAssistant.prototype.cleanup = function(){
    Mojo.Log.info("******** INTO AppAssistant CLEANUP");
}


AppAssistant.prototype.handleLaunch = function(launchParams){
    _appData.get();
    _myJid = _appData.get().userId + "@s.whatsapp.net";
    
    _depotDB.load(function(){
        this.handleLaunchAux(launchParams);
    }
.bind(this), false);
}

AppAssistant.prototype.handleLaunchAux = function(launchParams){
    Mojo.Locale.set(_depotDB.prefs.language);
    PalmServices.subscribeDisplayManager();
    
    try {
        _mainStageController = this.controller.getStageController(_mainStage);
        _dashboardStageController = this.controller.getStageController(_notificationStage);
        
        
        if (!launchParams || launchParams.action == "openChat") {
            Mojo.Log.info("controller is: " + _mainStageController);
            
            if (_mainStageController) {
                // Application already running (scenario 2)
                Mojo.Log.info("Relaunch!");
                _mainStageController.activate();
                
                if (launchParams && launchParams.action == "openChat") 
                    this.openChat(launchParams.chats);
                
            }
            else {
                // Need to launch the stage and scene (scenario 1)
                Mojo.Log.info("Launch new stage!");
                
                var sceneName;
                if (_appData.isRegistered()) {
                    // sceneName = "main";
                    sceneName = "chats-list";
                }
                else {
                    sceneName = "account";
                }
                
                var stageArgs = {
                    name: _mainStage,
                    lightweight: true
                };
                var onSuccess = function(controller){
                    _mainStageController = controller;
                    _dashboardStageController = null;
                    _mojowhatsupPlugin.createElement(controller.window.document);
                    _plugin = controller.get('mojowhatsupPlugin');
                    _mojowhatsupPlugin.isReady = false;
                    _mojowhatsupPlugin.isRunnerExecuting = false;
                    _networkConnected = false;
                    _plugin.ready = _mojowhatsupPlugin.ready.bind(_mojowhatsupPlugin);
                    _mojowhatsupPlugin.whenReady(function(){
                        _mojowhatsupPlugin.registerHandlers();
                        if (sceneName == "chats-list" && launchParams) {
                            controller.pushScene(sceneName, false);
                            this.openChat(launchParams.chats);
                        }
                        else {
                            controller.pushScene(sceneName);
                        }
                    }
.bind(this));
                };
                if (_dashboardStageController) {
                    this.controller.closeStage(_notificationStage);
                }
                
                this.controller.createStageWithCallback(stageArgs, onSuccess.bind(this));
            }
        }
        else 
            if (launchParams.action == "dashboard") {
                Mojo.Log.info(" Launch Parameters: %j", launchParams)
                
                if (!_dashboardStageController && launchParams && launchParams.action == "dashboard") {
                    var onSuccess = function(controller){
                        _dashboardStageController = controller;
                        _mainStageController = null;
                        _mojowhatsupPlugin.createElement(controller.window.document);
                        _plugin = controller.get('mojowhatsupPlugin');
                        _mojowhatsupPlugin.isReady = false;
                        _mojowhatsupPlugin.isRunnerExecuting = false;
                        _networkConnected = false;
                        _plugin.ready = _mojowhatsupPlugin.ready.bind(_mojowhatsupPlugin);
                        _mojowhatsupPlugin.whenReady(function(){
                            _mojowhatsupPlugin.registerHandlers();
                            controller.pushScene('dashboard');
                        });
                    };
                    
                    this.controller.createStageWithCallback({
                        name: _notificationStage,
                        lightweight: true
                    }, onSuccess.bind(this), 'dashboard');
                }
            }
            else 
                if (launchParams.action == "timeout" && launchParams.type == "background") {
                    if (_chatsAssistant == null && _dashboardAssistant == null) {
                        this.handleLaunch({
                            action: "dashboard"
                        });
                    }
                    else {
                        if (_plugin != null) {
							PalmServices.setActivity(30000);
                            _mojowhatsupPlugin.safePluginCall(function(){
                                _plugin.closeConnection();
                            });
                        }
                        PalmServices.setWakeUpAlarmBG();
                    }
                }
        //                }
    } 
    catch (e) {
        Mojo.Log.logException(e, "AppAssistant#handleLaunch");
    }
}

AppAssistant.prototype.startBG = function(background){
    if (_contactsImported) {
        _mojowhatsupPlugin.safePluginCall(function(){
            delete _mediaUploads;
            delete _mediaDownloads;
            _mediaUploads = new HashTable();
            _mediaDownloads = new HashTable();
            
            _myJid = _appData.cookieData.userId + "@s.whatsapp.net";
            if (!_appData.cookieData.passwordV2) {
                _appData.put("password", _plugin.processPassword(_appData.cookieData.password));
                _appData.put("passwordV2", true);
            }
            _plugin.startBG(_appData.cookieData.userId, _appData.cookieData.password, _appData.cookieData.pushName, (background ? "true" : "false"), (_depotDB.prefs.invisibleMode ? "true" : "false"));
        });
    }
    else {
        setTimeout(this.startBG.bind(this), 30);
    }
}

AppAssistant.prototype.openChat = function(chats){
    if (chats) {
        if (chats.length > 1) {
            var allFromTheSame = true;
            var jid = null;
            var chat = null;
            for (var i = 0; i < chats.length; i++) {
                if (chats[i].unread > 0 && chats[i].jid != jid) {
                    if (jid == null) {
                        jid = chats[i].jid;
                        chat = chats[i];
                    }
                    else {
                        allFromTheSame = false;
                        break;
                    }
                }
            }
            if (allFromTheSame) 
                chats = [chat];
        }
        
        if (chats.length > 1) {
            if (_openChatAssistant != null) 
                _mainStageController.popScene();
            if (_chatsAssistant != null) 
                _mainStageController.activate();
        }
        else {
            _appDB.findChat(chats[0].jid, function(fChat){
                if (fChat) {
                    if (_openChatAssistant != null && _openChatAssistant.chat.jid != chats[0].jid) {
                        _mainStageController.swapScene("chat", fChat);
                    }
                    else 
                        if (_openChatAssistant != null) {
                            _mainStageController.activate();
                        }
                        else 
                            if (_chatsAssistant != null) {
                                _mainStageController.pushScene("chat", fChat);
                            }
                            else {
                                _mainStageController.pushScene("chat", fChat);
                            }
                }
            });
        }
    }
};

AppAssistant.prototype.notifyUpdateGroup = function(group){

}

AppAssistant.prototype.notifyUpdateChats = function(notMe, jid){
    Mojo.Log.info("[AppAssistant]Received notifyUpdateChats!")
    
    if (_mainAssistant != null && _mainAssistant !== notMe) 
        _mainAssistant.updateChats();
    if (_chatsAssistant != null && _chatsAssistant !== notMe) {
        if (jid) {
            _appDB.findChat(jid, function(chat){
                _chatsAssistant.updateChats(chat);
            });
        }
        else {
            _chatsAssistant.updateChats();
        }
    }
    
    if (jid && _openChatAssistant != null && _openChatAssistant.chat.jid == jid) {
        _openChatAssistant.updateChat();
    }
}


AppAssistant.prototype.notifyUpdateBroadcast = function(message){
    Mojo.Log.info("[AppAssistant]Received notifyBroadcastChats!")
    if (_mainAssistant != null) 
        _mainAssistant.updateBroadcasts();
    
    if (_chatsAssistant != null) 
        _chatsAssistant.updateChats();
    
    if (message && _broadcastAssistant != null) {
        if (_broadcastAssistant.params.action == "info" && _broadcastAssistant.params.chat.jid == message.keyId) {
            if (message.remote_jid == "broadcast") {
                _broadcastAssistant.updateBroadcastStatus(message);
            }
            else {
                _appDB.findGroup(message.keyId, function(group){
                    _appDB.findChat(message.keyId, function(chat){
                        _broadcastAssistant.updateBroadcastStatus(message, group, chat);
                    });
                });
            }
        }
    }
}



AppAssistant.prototype.notifyNewMessage = function(chat, msg){
    Mojo.Log.info("[AppAssistant]Received notifyNewMessage!")
    if (_openChatAssistant != null) {
        if (_openChatAssistant.chat.jid == msg.remote_jid) {
            _openChatAssistant.updateNewMessage(msg);
            
            if (_mainStageController.isActiveAndHasScenes() && _displayOn) 
                return;
        }
    }
    
    if (_dashboardAssistant != null) 
        _dashboardAssistant.updateDashboardText(chat, msg);
    
    
    if (!msg.from_me) 
        this.alertNewMessage(chat, msg);
}

AppAssistant.prototype.alertChatExported = function(result){
    var bannerText = "";
    var icon = "";
    if (result == "ok") {
        icon = 'images/status-downloaded.png';
        bannerText = $L("Message history saved successfully!");
    }
    else {
        icon = 'images/status-error.png';
        bannerText = $L("Error saving message history!");
    }
    this.controller.showBanner({
        icon: icon,
        messageText: bannerText,
    }, {}, "chatExported");
}

AppAssistant.prototype.alertNewMessage = function(chat, msg){
    var name = this.getNameForJid(chat, msg);
    var bannerText = (name == null ? "" : name + ": ") + msg.formatTextMessage(false, false, 0, true);
    
    var isGroup = chat.isGroup && !msg.isbroadcast;
    
    var currentDate = new Date().getTime();
    
    if (isGroup && chat.muteexpiry) {
        if (chat.muteexpiry > (currentDate / 1000)) 
            return;
    }
    
    var launchArguments = {
        action: "openChat",
        chats: [chat]
    };
    
    if ((isGroup && _depotDB.prefs.groupSound != "silence") || (!isGroup && _depotDB.prefs.personSound != "silence")) {
        if ((isGroup && ((currentDate - _lastSoundGroupNotification) > _MINIMUM_NOTIFICATION_INTERVAL)) ||
        (!isGroup && ((currentDate - _lastSoundPersonNotification) > _MINIMUM_NOTIFICATION_INTERVAL))) {
            if ((isGroup && _depotDB.prefs.groupSound == "system") || (!isGroup && _depotDB.prefs.personSound == "system")) {
                this.controller.playSoundNotification("notifications");
            }
            else 
                if (isGroup && _depotDB.prefs.groupSound == "custom") {
                    this.controller.playSoundNotification("notifications", _depotDB.prefs.groupTonePath);
                }
                else 
                    if (!isGroup && _depotDB.prefs.personSound == "custom") {
                        this.controller.playSoundNotification("notifications", _depotDB.prefs.personTonePath);
                    }
        }
        if (isGroup) 
            _lastSoundGroupNotification = currentDate;
        else 
            _lastSoundPersonNotification = currentDate;
    }
    
    if ((isGroup && _depotDB.prefs.groupVibrate) || (!isGroup && _depotDB.prefs.personVibrate)) {
        if ((isGroup && ((currentDate - _lastVibrateGroupNotification) > _MINIMUM_NOTIFICATION_INTERVAL)) ||
        (!isGroup && ((currentDate - _lastVibratePersonNotification) > _MINIMUM_NOTIFICATION_INTERVAL))) {
            this.controller.playSoundNotification("vibrate");
        }
        if (isGroup) 
            _lastVibrateGroupNotification = currentDate;
        else 
            _lastVibratePersonNotification = currentDate;
    }
    
    if ((isGroup && _depotDB.prefs.groupBanner) || (!isGroup && _depotDB.prefs.personBanner)) {
        this.controller.showBanner({
            messageText: bannerText,
        }, launchArguments, "newMessage");
    }
    
    //Patch to report bannerMessage to BT-watch SE MBW-150
    // this.getTweaksPrefs = new Mojo.Service.Request("palm://org.webosinternals.tweaks.prefs/", {
    // method : 'get',
    // parameters : {
    // 'owner' : "bluetooth-mbw150",
    // keys : ["mbwMJWhatsup"]
    // },
    // onSuccess : function(response) {
    // if (response) {
    // if (response.mbwMJWhatsup == true) {
    
    //Report BannerMessage to SE-Watch MBW150
    this.mwatchRequest = new Mojo.Service.Request('palm://com.palm.applicationManager', {
        method: 'open',
        parameters: {
            id: "de.metaviewsoft.mwatch",
            params: {
                command: "SMS",
                info: (isGroup ? "[" + chat.chatName + "]" : "") + bannerText,
                wordwrap: true
            }
        },
        onSuccess: function(){
        },
        onFailure: function(){
        }
    });
    //}
    // }
    // }.bind(this)
    // });
    
    if ((isGroup && _depotDB.prefs.groupBlink) || (!chat.isGroup && _depotDB.prefs.personBlink)) {
        if (_mainStageController != null) 
            _mainStageController.indicateNewContent(true);
        else 
            if (_dashboardAssistant != null) 
                _dashboardStageController.indicateNewContent(true);
    }
}

AppAssistant.prototype.notifyMessageStatusUpdated = function(message){
    Mojo.Log.info("[AppAssistant]Received notifyMessageStatusUpdated!")
    if (_openChatAssistant != null) {
        if ((_openChatAssistant.chat.jid == message.remote_jid)) {
            _openChatAssistant.updateMessageStatus(message);
        }
    }
    
    if (_chatsAssistant != null) {
        _chatsAssistant.updateMessageStatus(message);
    }
}


AppAssistant.prototype.requestStatus = function(){
    if (_contactsImported) {
        _statusRequest = new StatusRequest();
        _statusRequest.getMyStatus();
        _statusRequest = new StatusRequest();
        _statusRequest.sync();
    }
    else {
        setTimeout(this.requestStatus.bind(this), 10);
    }
}


AppAssistant.prototype.syncContacts = function(force){
    var timeDif = new Date().getTime() - _appData.get().lastStatusRequest;
    Mojo.Log.info("Time dif sync %d", timeDif);
    if (force || (timeDif > _SYNC_INTERVAL)) {
        _contactsImported = false;
        _appDB.importContacts();
        this.requestStatus();
    }
    else {
        _appDB.fillJidNames(function(){
            _contactsImported = true;
        });
    }
}

AppAssistant.prototype.loadContacts = function(callback){
    if (_contactsImported) {
        _appDB.getAllContacts(function(contacts){
            if (callback) 
                callback(contacts);
        }
.bind(this));
    }
    else {
        setTimeout(this.loadContacts.bind(this), 10, callback);
    }
}

AppAssistant.prototype.notifyContactInfoUpdated = function(contactInfo){
    Mojo.Log.info("[AppAssistant]Received notifyContactInfoUpdated!")
    
    var found = false;
    
    if (_chatsAssistant != null && _depotDB.prefs.showOnline) {
        found = _chatsAssistant.updateContactInfo(contactInfo);
    }
    
    if (_contactsAssistant != null && _depotDB.prefs.showOnline) {
        _contactsAssistant.updateContactInfo(contactInfo);
        found = true;
    }
    
    if (_openChatAssistant != null) {
        if (_openChatAssistant.chat.jid == contactInfo.jid) {
            _openChatAssistant.updateContactInfo(contactInfo);
            found = true;
        }
    }
    
    if (!found && contactInfo.status != 2) {
        _mojowhatsupPlugin.safePluginCall(function(){
            _plugin.sendUnsubscribe(contactInfo.jid);
        });
    }
}

AppAssistant.prototype.getNameForJid = function(chat, msg, notifyname){
    var name = "";
    
    if (msg.from_me) 
        return null;
    
    if (msg.isNotification()) 
        return null;
    
    var name = "";
    
    if (chat.isGroup) {
        if (_contactJidNames.getItem(msg.remote_resource) !== undefined) 
            return _contactJidNames.getItem(msg.remote_resource);
        else 
            name = "+" + Message.removeDomainFromJid(msg.remote_resource);
    }
    else 
        if (_contactJidNames.getItem(msg.remote_jid) !== undefined) 
            return _contactJidNames.getItem(msg.remote_jid);
        else 
            name = "+" + Message.removeDomainFromJid(msg.remote_jid);
    
    if (notifyname) 
        name += " (" + msg.notifyname + ")";
    
    return name;
    // return ((msg.notifyname != null && msg.notifyname != "") ? msg.notifyname : chat.jid);
}

AppAssistant.prototype.resetApp = function(){
    _appData.reset();
    _exitApp = true;
    _myJid = "";
    _appDB.reset(function(){
        this.notifyUpdateChats(null, null);
        _contactsImported = true;
        if (_chatsAssistant != null) {
            _chatsAssistant.updateMyStatus();
            this.loadContacts();
        }
    }
.bind(this));
}

AppAssistant.prototype.isTouchPad = function(){
    if (Mojo.Environment.DeviceInfo.modelNameAscii.indexOf("ouch") > -1) {
        return true;
    }
    
    if (Mojo.Environment.DeviceInfo.screenWidth == 1024) {
        return true;
    }
    
    if (Mojo.Environment.DeviceInfo.screenHeight == 1024) {
        return true;
    }
    
    return false;
}

AppAssistant.prototype.isPre3 = function(){
    if (Mojo.Environment.DeviceInfo.screenHeight == 800) {
        return true;
    }
    
    if (Mojo.Environment.DeviceInfo.screenWidth == 800) {
        return true;
    }
    
    return false;
}
