function DashboardAssistant(){
    this.chats = [];
    this.nunread = 0;
    this.lastChat = null;
    this.lastMessage = null;
    this.closed = false;
    this.timeout = null;
}

DashboardAssistant.prototype.setup = function(){
    _dashboardAssistant = this;
    PalmServices.clearWakeUpAlarmBG();
    this.switchHandler = this.launchMain.bindAsEventListener(this);
    this.dashboardInfoElement = this.controller.get("dashboardinfo");
    Mojo.Event.listen(this.dashboardInfoElement, Mojo.Event.tap, this.switchHandler);
};

DashboardAssistant.prototype.ready = function(){
	_appAssistant.syncContacts();
    _appAssistant.startBG(true);
    _mojowhatsupPlugin.whenRunnerExecuting(function(){
        PalmServices.subscribeNetworkStatus();
        //        this.timerSendActive = setTimeout(function(){
        //            if (_plugin != null) 
        //                _plugin.sendActive(0)
        //        }, 10000);
    }
.bind(this));
    
    this.waitForCompletion();
}

DashboardAssistant.prototype.waitForCompletion = function(){
    if (_mojowhatsupPlugin.isRunnerExecuting && _contactsImported) {
        this.updateDashboardText();
        if (_depotDB.prefs.closeifnomessages != 0) {
            PalmServices.setActivity(parseInt(_depotDB.prefs.closeifnomessages) + 2000);
            this.timeout = setTimeout(function(){
                if (this.nunread == 0) {
                    Mojo.Controller.getAppController().closeStage(_notificationStage);
                }
            }
.bind(this), parseInt(_depotDB.prefs.closeifnomessages));
        }
        else {
            PalmServices.setActivity(17000);
        }
    }
    else {
        setTimeout(this.waitForCompletion.bind(this), 30);
    }
}

DashboardAssistant.prototype.launchMain = function(){
    this.launch = true;
    var params = undefined;
    if (this.nunread == 1) 
        params = {
            action: "openChat",
            chats: [this.lastChat]
        };
    else 
        params = {
            action: "openChat",
            chats: this.chats
        };
    
    this.controller.serviceRequest("palm://com.palm.applicationManager", {
        method: "open",
        parameters: {
            id: "com.palm.mojowhatsup",
            params: params
        }
    });
    Mojo.Controller.getAppController().closeStage(_notificationStage);
};

DashboardAssistant.prototype.activate = function(event){
};

DashboardAssistant.prototype.deactivate = function(event){
};

DashboardAssistant.prototype.cleanup = function(event){
    clearTimeout(this.timeout);
    
    if (!this.closed) {
        _dashboardAssistant = null;
        PalmServices.clearWakeUpAlarmBG();
        
        this.closed = true;
        Mojo.Event.stopListening(this.dashboardInfoElement, Mojo.Event.tap, this.switchHandler);
        
        try {
            _plugin.exitPlugin();
            _plugin = null;
        } 
        catch (ex) {
        }
        
        if (!this.launch) {
            PalmServices.setWakeUpAlarmBG();
        }
    }
};

DashboardAssistant.prototype.updateDashboardText = function(chat, msg){
    this.lastChat = chat;
    this.lastMessage = msg;
    
    _appDB.getAllChatsWithMessages(function(chats){
        this.nunread = 0;
        this.chats = chats;
        this.allFromSame = true;
        var lastChat = null;
        for (var i = 0; i < chats.length; i++) {
            if (lastChat == null && chats[i].unread > 0) {
                lastChat = chats[i];
            }
            
            if (chats[i].unread > 0 && lastChat && lastChat.jid != chats[i].jid) {
                this.allFromSame = false;
            }
            
            this.nunread += chats[i].unread;
        }
        
        if (!chat) {
            this.lastChat = lastChat;
        }
        
        var renderInfo;
        if (!this.lastChat) {
            renderInfo = Mojo.View.render({
                object: {},
                template: "dashboard/nomessages-template"
            });
        }
        else {
            var title = emojify(this.lastChat.chatName, 16);
            var jidName = _appAssistant.getNameForJid(this.lastChat, this.lastChat.lastMessage);
            var message = this.lastChat.lastMessage.formatTextMessage(false, true, null, true);
            var subtitle = (jidName == null || !this.lastChat.isGroup ? message : jidName + ": " + message);
            var image = (this.lastChat.picturepath && this.allFromSame ? this.lastChat.picturepath : "images/mojowhatsup48.png")
            renderInfo = Mojo.View.render({
                object: {
                    title: title,
                    subtitle: subtitle,
                    nunread: this.nunread,
                    image: image
                },
                template: "dashboard/notification-template"
            });
        }
        this.controller.get('dashboardinfo').innerHTML = renderInfo;
    }
.bind(this), true);
}

