function PrefsAssistant(){
    _prefsAssistant = this;
    
    this.languageChoices = [{
        label: $L("English"),
        value: "en_gb"
    }, {
        label: $L("Spanish"),
        value: "es_es"
    }, {
        label: $L("German"),
        value: "de_de"
    }, {
        label: $L("Italian"),
        value: "it_it"
    }, {
        label: $L("French"),
        value: "fr_fr"
    }, {
        label: $L("Dutch"),
        value: "nl_nl"
    }, {
        label: $L("Chinese (Simplified)"),
        value: "zh_cn"
    }, {
        label: $L("Chinese (Traditional)"),
        value: "zh_tw"
    }, {
        label: $L("Chinese (Hong Kong)"),
        value: "zh_hk"
    }, {
        label: $L("Russian"),
        value: "ru_ru"
    }];
    
    this.soundChoices = [{
        label: $L("System sound"),
        value: "system"
    }, {
        label: $L("Custom sound"),
        value: "custom"
    }, {
        label: $L("Silence"),
        value: "silence"
    }];
    
    this.timeouts = [ //	{
    //        label: $L('As items arrive'),
    //        value: "asArrive"
    //    }, 
    {
        label: '5 ' + $L('minutes'),
        value: "00:05:00"
    }, {
        label: '10 ' + $L('minutes'),
        value: "00:10:00"
    }, {
        label: '15 ' + $L('minutes'),
        value: "00:15:00"
    }, {
        label: '20 ' + $L('minutes'),
        value: "00:20:00"
    }, {
        label: '30 ' + $L('minutes'),
        value: "00:30:00"
    }, {
        label: '45 ' + $L('minutes'),
        value: "00:45:00"
    }, {
        label: '1 ' + $L('hour'),
        value: "01:00:00"
    }, {
        label: '6 ' + $L('hours'),
        value: "06:00:00"
    }, {
        label: '12 ' + $L('hours'),
        value: "12:00:00"
    }, {
        label: '24 ' + $L('hours'),
        value: "24:00:00"
    }];
    
    this.imageChoices = [{
        label: $L("Default"),
        value: "default"
    }, {
        label: $L("Custom image"),
        value: "custom"
    }, {
        label: $L("None"),
        value: "none"
    }];
    
    this.bubbleChoices = [{
        label: $L("Palm"),
        value: "classic"
    }, {
        label: $L("Whatsapp"),
        value: "modern"
    }];
    
    this.closedashChoices = [{
        label: "15 " + $L("seconds"),
        value: "15000"
    }, {
        label: "30 " + $L("seconds"),
        value: "30000"
    }, {
        label: "45 " + $L("seconds"),
        value: "45000"
    }, {
        label: "60 " + $L("seconds"),
        value: "60000"
    }];
    
}

PrefsAssistant.prototype.setup = function(){
    if (_chatsAssistant != null && _appAssistant.isTouchPad()) {
        var menuModel = {
            visible: true,
            items: [{
                icon: "back",
                command: "goBack"
            }]
        };
        
        this.controller.setupWidget(Mojo.Menu.commandMenu, this.attributes = {
            spacerHeight: 0,
            menuClass: 'no-fade'
        }, menuModel);
    }
    
    this.controller.get("langTitle").update($L("Language"));
    this.controller.get("headerTitle").update($L("Preferences"));
    this.controller.get("personGroupTitle").update($L("Persons notifications"));
    this.controller.get("groupGroupTitle").update($L("Groups notifications"));
    this.controller.get("bgGroupTitle").update($L("App in background"));
    this.controller.get("dashboardGroupTitle").update($L("Notification dashboard"));
    this.controller.get("personVibrateLabel").update($L("Vibrate"));
    this.controller.get("groupVibrateLabel").update($L("Vibrate"));
    this.controller.get("personBannerLabel").update($L("Show banner"));
    this.controller.get("groupBannerLabel").update($L("Show banner"));
    this.controller.get("personBlinkLabel").update($L("Light bar"));
    this.controller.get("groupBlinkLabel").update($L("Light bar"));
    this.controller.get("personToneLabel").update($L("Tone"));
    this.controller.get("groupToneLabel").update($L("Tone"));
    this.controller.get("chatsGroupTitle").update($L("Messages text font"));
    this.controller.get("resizeImage").update($L("Reduce image before sending"));
    this.controller.get("phoneTypesTitle").update($L("Contacts"));
    this.controller.get("backimageGroupTitle").update($L("Chat background"));
    this.controller.get("backimageLabel").update($L("Image path"));
    this.controller.get("autodownloadTitle").update($L("Auto-download media"));
    this.controller.get("autodownloadImageLabel").update(capitaliseFirstLetter($L("image")));
    this.controller.get("autodownloadVideoLabel").update(capitaliseFirstLetter($L("video")));
    this.controller.get("autodownloadAudioLabel").update(capitaliseFirstLetter($L("audio")));
    this.controller.get("autodownloadVoiceNoteLabel").update(capitaliseFirstLetter($L("voice note")));
    this.controller.get("showOnlineLabel").update(capitaliseFirstLetter($L("Show status in chats and contacts lists")));
    this.controller.get("invisibleModeLabel").update($L("Invisible mode"));
    this.controller.get("invisibleMessage").update($L("If enabled your last seen timestamp will not be up to date and your contacts will not see your online/typing status. But also you will not see the online/typing status of your contacts."));
    
    this.controller.setupWidget('invisibleMode', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.invisibleMode
    });
    
    this.controller.setupWidget("spinnerId", this.attributesSpinner = {
        spinnerSize: "small"
    }, this.modelSpinner = {
        spinning: false
    });
    
    this.controller.get('spinnerId').hide();
    
    this.controller.get('profilePictureTitle').update($L("Profile picture"));
    this.setPicture();
    this.controller.listen("profileImage", Mojo.Event.tap, this.profileImageHandler.bindAsEventListener(this));
    
    this.controller.setupWidget('language', {
        label: $L('Language'),
        choices: this.languageChoices,
        modelProperty: "locale"
    }, {
        locale: (_depotDB.prefs.language)
    });
    
    this.controller.setupWidget('personSoundSelector', {
        label: $L('Sound'),
        choices: this.soundChoices,
        modelProperty: "currentSound"
    }, {
        currentSound: _depotDB.prefs.personSound
    });
    
    if (_depotDB.prefs.personSound == "custom") {
        this.controller.get('personTonePathRow').show();
    }
    else {
        this.controller.get('personTonePathRow').hide();
    }
    this.controller.get('personTonePath').update(_depotDB.prefs.personToneName);
    
    this.controller.setupWidget('personVibrateToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.personVibrate
    });
    
    this.controller.setupWidget('personBannerToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.personBanner
    });
    
    this.controller.setupWidget('personBlinkToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.personBlink
    });
    
    this.controller.setupWidget('groupSoundToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.groupSound
    });
    
    this.controller.setupWidget('groupSoundSelector', {
        label: $L('Sound'),
        choices: this.soundChoices,
        modelProperty: "currentSound"
    }, {
        currentSound: _depotDB.prefs.groupSound
    });
    
    if (_depotDB.prefs.groupSound == "custom") {
        this.controller.get('groupTonePathRow').show();
    }
    else {
        this.controller.get('groupTonePathRow').hide();
    }
    this.controller.get('groupTonePath').update(_depotDB.prefs.groupToneName);
    
    this.controller.setupWidget('groupVibrateToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.groupVibrate
    });
    
    this.controller.setupWidget('groupBannerToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.groupBanner
    });
    
    this.controller.setupWidget('groupBlinkToggle', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.groupBlink
    });
    
    this.controller.setupWidget('bgTimeoutSelector', {
        label: $L('Check new messages every'),
        choices: this.timeouts,
        modelProperty: 'currentTimeout',
        multiline: true
    }, {
        currentTimeout: _depotDB.prefs.backgroundTimeout
    });
    
    
    this.controller.setupWidget('closenomessagesSelector', {
        label: $L("Close"),
        choices: [{
            label: $L("When no messages"),
            value: "closeno"
        }, {
            label: $L("Never"),
            value: "never"
        }],
        modelProperty: "currentClose"
    }, {
        currentClose: (_depotDB.prefs.closeifnomessages > 0 ? "closeno" : "never")
    });
    
    this.controller.setupWidget('closedashSelector', {
        label: $L("Close after"),
        multiline: true,
        choices: this.closedashChoices,
        modelProperty: 'currentClose'
    }, this.closedashModel = {
        currentClose: _depotDB.prefs.closeifnomessages
    });
    
    if (_depotDB.prefs.closeifnomessages > 0) {
        this.controller.get("rowClosedash").show();
        this.controller.get("rowClosenomessages").className = "palm-row first";
    }
    else {
        this.controller.get("rowClosedash").hide();
        this.controller.get("rowClosenomessages").className = "palm-row single";
    }
    
    this.controller.setupWidget('chatTextSize', {
        label: $L('Size'),
        choices: [{
            label: 14,
            value: 14
        }, {
            label: 16,
            value: 16
        }, {
            label: 18,
            value: 18
        }, {
            label: 20,
            value: 20
        }, {
            label: 22,
            value: 22
        }, {
            label: 24,
            value: 24
        }],
        modelProperty: 'currentSize'
    }, {
        currentSize: _depotDB.prefs.chatTextSize
    });
    
    this.controller.setupWidget('imageSize', {
        label: $L('Size'),
        choices: [{
            label: $L("No reduce"),
            value: 0
        }, {
            label: "240 x 320",
            value: 320
        }, {
            label: "480 x 640",
            value: 640
        }, {
            label: "600 x 800",
            value: 800
        }, {
            label: "768 x 1024",
            value: 1024
        }, {
            label: "1024 x 1280",
            value: 1280
        }],
        modelProperty: 'currentSize'
    }, {
        currentSize: _depotDB.prefs.imageResolution
    });
    
    this.controller.setupWidget('phoneType', {
        label: $L('Phone type'),
        choices: [{
            label: $L("All phone types"),
            value: "all"
        }, {
            label: $L("Only mobile"),
            value: "mobile"
        }, {
            label: $L("Mobile and work"),
            value: "mobilework"
        }],
        modelProperty: 'currentSize'
    }, {
        currentSize: _depotDB.prefs.phoneTypes
    });
    
    
    this.controller.setupWidget('bubbleclassSelector', {
        label: $L('Bubble class'),
        choices: this.bubbleChoices,
        modelProperty: "currentBubble"
    }, {
        currentBubble: _depotDB.prefs.bubbleclass
    });
    
    this.controller.setupWidget('backimageSelector', {
        label: $L('Image'),
        choices: this.imageChoices,
        modelProperty: "currentImage"
    }, {
        currentImage: _depotDB.prefs.backimageType
    });
    
    if (_depotDB.prefs.backimageType == "custom") {
        this.controller.get('backimagePathRow').show();
        this.controller.get('rowBackimage').className = "palm-row";
    }
    else {
        this.controller.get('backimagePathRow').hide();
        this.controller.get('rowBackimage').className = "palm-row last";
    }
    this.controller.get('backimagePath').update(_depotDB.prefs.backimagePath);
    
    
    this.controller.setupWidget('autodownloadImage', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.autodownloadImage
    });
    
    this.controller.setupWidget('autodownloadVideo', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.autodownloadVideo
    });
    
    this.controller.setupWidget('autodownloadAudio', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.autodownloadAudio
    });
    
    this.controller.setupWidget('autodownloadVoiceNote', {
        modelProperty: "value"
    }, {
        value: _depotDB.prefs.autodownloadVoiceNote
    });
    
    this.controller.setupWidget('showOnline', 
	{
        modelProperty: "value"
    }, this.showOnlineModel = {
        value: _depotDB.prefs.showOnline
    });
    
    this.controller.listen('invisibleMode', Mojo.Event.propertyChanged, this.invisibleModeHandler.bindAsEventListener(this));
    this.controller.listen('language', Mojo.Event.propertyChanged, this.languageHandler.bindAsEventListener(this));
    this.controller.listen('personSoundSelector', Mojo.Event.propertyChanged, this.personSoundHandler.bindAsEventListener(this));
    this.controller.listen('personTonePathRow', Mojo.Event.tap, this.personTonePathTapHandler.bindAsEventListener(this));
    this.controller.listen('personVibrateToggle', Mojo.Event.propertyChanged, this.personVibrateHandler.bindAsEventListener(this));
    this.controller.listen('personBannerToggle', Mojo.Event.propertyChanged, this.personBannerHandler.bindAsEventListener(this));
    this.controller.listen('personBlinkToggle', Mojo.Event.propertyChanged, this.personBlinkHandler.bindAsEventListener(this));
    this.controller.listen('groupSoundSelector', Mojo.Event.propertyChanged, this.groupSoundHandler.bindAsEventListener(this));
    this.controller.listen('groupTonePathRow', Mojo.Event.tap, this.groupTonePathTapHandler.bindAsEventListener(this));
    this.controller.listen('groupVibrateToggle', Mojo.Event.propertyChanged, this.groupVibrateHandler.bindAsEventListener(this));
    this.controller.listen('groupBannerToggle', Mojo.Event.propertyChanged, this.groupBannerHandler.bindAsEventListener(this));
    this.controller.listen('groupBlinkToggle', Mojo.Event.propertyChanged, this.groupBlinkHandler.bindAsEventListener(this));
    this.controller.listen('bgTimeoutSelector', Mojo.Event.propertyChanged, this.bgTimeoutHandler.bindAsEventListener(this));
    this.controller.listen('chatTextSize', Mojo.Event.propertyChanged, this.chatTextSizeHandler.bindAsEventListener(this));
    this.controller.listen('imageSize', Mojo.Event.propertyChanged, this.imageSizeHandler.bindAsEventListener(this));
    this.controller.listen('phoneType', Mojo.Event.propertyChanged, this.phoneTypeHandler.bindAsEventListener(this));
    this.controller.listen('bubbleclassSelector', Mojo.Event.propertyChanged, this.bubbleclassHandler.bindAsEventListener(this));
    this.controller.listen('backimageSelector', Mojo.Event.propertyChanged, this.backimageHandler.bindAsEventListener(this));
    this.controller.listen('backimagePathRow', Mojo.Event.tap, this.backimagePathTapHandler.bindAsEventListener(this));
    this.controller.listen('closedashSelector', Mojo.Event.propertyChanged, this.closedashHandler.bindAsEventListener(this));
    this.controller.listen('closenomessagesSelector', Mojo.Event.propertyChanged, this.closenomessagesHandler.bindAsEventListener(this));
    this.controller.listen('autodownloadImage', Mojo.Event.propertyChanged, this.autoImageHandler.bindAsEventListener(this));
    this.controller.listen('autodownloadVideo', Mojo.Event.propertyChanged, this.autoVideoHandler.bindAsEventListener(this));
    this.controller.listen('autodownloadAudio', Mojo.Event.propertyChanged, this.autoAudioHandler.bindAsEventListener(this));
    this.controller.listen('autodownloadVoiceNote', Mojo.Event.propertyChanged, this.autoVoiceNoteHandler.bindAsEventListener(this));
    this.controller.listen('showOnline', Mojo.Event.propertyChanged, this.showOnlineHandler.bindAsEventListener(this));
    
    // var mypictureid = _appData.cookieData.mypictureid;
    try {
        // _plugin.sendGetPicture(_myJid, "preview", mypictureid, "");
        _plugin.sendGetPictureIds(JSON.stringify([_myJid]));
    } 
    catch (e) {
        Mojo.Log.error("error plugin onSendGetPictureIds %j", e);
    }
}

PrefsAssistant.prototype.setPicture = function(){
    var imgSize = '80:80';
    if (_appAssistant.isPre3()) 
        imgSize = '120:120';
    
    if (_appData.cookieData.mypicture != "") {
        this.controller.get('profileImage').update('<div class="profile-image picture" style="background-image:url(/var/luna/data/extractfs' + encodeURIComponent(_appData.cookieData.mypicture) + ':0:0:' + imgSize + ':3)"></div>');
    }
    else {
        this.controller.get('profileImage').update('<div class="profile-image person-icon"></div>');
    }
}

PrefsAssistant.prototype.updatePicture = function(path){
    if (path != "error") {
        this.setPicture();
    }
    
    this.modelSpinner.spinning = false;
    this.controller.modelChanged(this.modelSpinner);
    this.controller.get("spinnerId").hide();
}

PrefsAssistant.prototype.profileImageHandler = function(event){
    Event.stop(event);
    var items = [];
    items.push({
        label: $L("Change"),
        command: "change"
    });
    
    if (_appData.cookieData.mypicture != "") {
        items.push({
            label: $L("View"),
            command: "view"
        });
        items.push({
            label: $L("Delete"),
            command: "delete"
        });
    }
    
    this.controller.popupSubmenu({
        onChoose: this.popupImageHandler,
        placeNear: this.controller.get("profileImage"),
        items: items
    });
}

PrefsAssistant.prototype.popupImageHandler = function(command){
    switch (command) {
        case 'change':
            var params = {
                kind: "image",
                actionName: $L("Send"),
                extensions: ["jpg"],
                crop: {
                    width: 320,
                    height: 320
                },
                onSelect: function(file){
                    this.modelSpinner.spinning = true;
                    this.controller.modelChanged(this.modelSpinner);
                    this.controller.get("spinnerId").show();
                    _mojowhatsupPlugin.safePluginCall(function(){
                        var cropInfo = {
                            size: 640,
                            scale: file.cropInfo.window.scale * 2.0,
                            x: Math.floor(file.cropInfo.window.suggestedXTop * file.cropInfo.window.scale * 2.0),
                            y: Math.floor(file.cropInfo.window.suggestedYTop * file.cropInfo.window.scale * 2.0)
                        };
                        _plugin.sendSetPicture(_myJid, file.fullPath, JSON.stringify(cropInfo));
                    }
.bind(this));
                }
.bind(this)
            };
            Mojo.FilePicker.pickFile(params, this.controller.stageController);
            break;
        case 'view':
            this.controller.stageController.pushScene("imageview", {
                path: _appData.cookieData.mypicture
            });
            break;
        case 'delete':
            this.modelSpinner.spinning = true;
            this.controller.modelChanged(this.modelSpinner);
            this.controller.get("spinnerId").show();
            
            _mojowhatsupPlugin.safePluginCall(function(){
                _plugin.sendSetPicture(_myJid, "", "");
            }
.bind(this));
            break;
    }
}

PrefsAssistant.prototype.languageHandler = function(event){
    _depotDB.putPrefs("language", event.value);
    try {
        Mojo.Locale.set(_depotDB.prefs.language);
    } 
    catch (e) {
        Mojo.Log.error("Error " + Object.toJSON(e));
    }
    _appAssistant.controller.getActiveStageController().activeScene().showAlertDialog({
        title: $L("Notification"),
        message: $L("It is necessary to restart the application so that this change can take effect"),
        choices: [{
            label: $L('Close application'),
            value: "close",
            type: 'affirmative'
        }],
        preventCancel: true,
        onChoose: function(value){
            _exitApp = true;
            if (value == 'close') {
                if (_dashboardStageController) 
                    _appAssistant.controller.closeStage(_notificationStage);
                if (_mainStageController) 
                    _appAssistant.controller.closeStage(_mainStage);
            }
        }
    });
    
}

PrefsAssistant.prototype.phoneTypeHandler = function(event){
    _depotDB.putPrefs("phoneTypes", String(event.value));
}

PrefsAssistant.prototype.imageSizeHandler = function(event){
    _depotDB.putPrefs("imageResolution", Number(event.value));
}

PrefsAssistant.prototype.chatTextSizeHandler = function(event){
    _depotDB.putPrefs("chatTextSize", Number(event.value));
}

PrefsAssistant.prototype.deactivate = function(event){
    if (_openChatAssistant != null) {
        _openChatAssistant.refreshList();
    }
}

PrefsAssistant.prototype.personTonePathTapHandler = function(event){
    Mojo.FilePicker.pickFile({
        onSelect: this.personTonePathSelectionHandler.bind(this),
        kinds: ["ringtone"],
        defaultKind: "ringtone",
        actionType: "open",
        filePath: _depotDB.prefs.personTonePath
    }, this.controller.stageController);
}

PrefsAssistant.prototype.groupTonePathTapHandler = function(event){
    Mojo.FilePicker.pickFile({
        onSelect: this.groupTonePathSelectionHandler.bind(this),
        kinds: ["ringtone"],
        defaultKind: "ringtone",
        actionType: "open",
        filePath: _depotDB.prefs.groupTonePath
    }, this.controller.stageController);
}

PrefsAssistant.prototype.personTonePathSelectionHandler = function(selection){
    _depotDB.putPrefs('personTonePath', selection.fullPath);
    _depotDB.putPrefs('personToneName', selection.name);
    this.controller.get("personTonePath").update(selection.name);
}

PrefsAssistant.prototype.groupTonePathSelectionHandler = function(selection){
    _depotDB.putPrefs('groupTonePath', selection.fullPath);
    _depotDB.putPrefs('groupToneName', selection.name);
    this.controller.get("groupTonePath").update(selection.name);
}

PrefsAssistant.prototype.handleCommand = function(event){
    if (event.type == Mojo.Event.command) {
        switch (event.command) {
            case 'goBack':
                this.controller.stageController.popScene();
                break;
        }
    }
}

PrefsAssistant.prototype.bgTimeoutHandler = function(event){
    _depotDB.putPrefs("backgroundTimeout", event.value);
}

PrefsAssistant.prototype.closedashHandler = function(event){
    _depotDB.putPrefs("closeifnomessages", event.value);
}

PrefsAssistant.prototype.closenomessagesHandler = function(event){
    if (event.value == "closeno") {
        this.controller.get("rowClosedash").show();
        this.controller.get("rowClosenomessages").className = "palm-row first";
        this.closedashModel.currentClose = 15000;
        this.controller.modelChanged(this.closedashModel);
        _depotDB.putPrefs("closeifnomessages", 15000);
    }
    else {
        this.controller.get("rowClosedash").hide();
        this.controller.get("rowClosenomessages").className = "palm-row single";
        _depotDB.putPrefs("closeifnomessages", 0);
    }
}

PrefsAssistant.prototype.personSoundHandler = function(event){
    _depotDB.putPrefs('personSound', event.value);
    if (event.value == "custom") {
        this.controller.get('personTonePathRow').show();
    }
    else {
        this.controller.get('personTonePathRow').hide();
    }
}

PrefsAssistant.prototype.invisibleModeHandler = function(event){
	_depotDB.putPrefs('invisibleMode', event.value);
	_appAssistant.startBG(false);
}

PrefsAssistant.prototype.personVibrateHandler = function(event){
    _depotDB.putPrefs('personVibrate', event.value);
}

PrefsAssistant.prototype.personBannerHandler = function(event){
    _depotDB.putPrefs('personBanner', event.value);
}

PrefsAssistant.prototype.personBlinkHandler = function(event){
    _depotDB.putPrefs('personBlink', event.value);
}

PrefsAssistant.prototype.groupSoundHandler = function(event){
    _depotDB.putPrefs('groupSound', event.value);
    if (event.value == "custom") {
        this.controller.get('groupTonePathRow').show();
    }
    else {
        this.controller.get('groupTonePathRow').hide();
    }
}

PrefsAssistant.prototype.bubbleclassHandler = function(event){
    _depotDB.putPrefs('bubbleclass', event.value);
}

PrefsAssistant.prototype.backimageHandler = function(event){
    _depotDB.putPrefs('backimageType', event.value);
    if (event.value == "custom") {
        this.controller.get('backimagePath').update("");
        this.controller.get('backimagePathRow').show();
        this.controller.get('rowBackimage').className = "palm-row";
    }
    else {
        this.controller.get('backimagePathRow').hide();
        this.controller.get('rowBackimage').className = "palm-row last";
    }
}

PrefsAssistant.prototype.backimagePathTapHandler = function(event){
    var params = {
        kind: "image",
        actionName: $L("Select"),
        extensions: ["jpg"],
        onSelect: function(file){
            Mojo.Log.info("Selected image %j", file);
            _depotDB.putPrefs('backimagePath', file.fullPath);
            this.controller.get('backimagePath').update(file.fullPath);
        }
.bind(this)
    }
    Mojo.FilePicker.pickFile(params, this.controller.stageController);
}

PrefsAssistant.prototype.groupVibrateHandler = function(event){
    _depotDB.putPrefs('groupVibrate', event.value);
}

PrefsAssistant.prototype.groupBannerHandler = function(event){
    _depotDB.putPrefs('groupBanner', event.value);
}

PrefsAssistant.prototype.groupBlinkHandler = function(event){
    _depotDB.putPrefs('groupBlink', event.value);
}

PrefsAssistant.prototype.autoImageHandler = function(event){
    _depotDB.putPrefs('autodownloadImage', event.value);
}

PrefsAssistant.prototype.autoVideoHandler = function(event){
    _depotDB.putPrefs('autodownloadVideo', event.value);
}

PrefsAssistant.prototype.autoAudioHandler = function(event){
    _depotDB.putPrefs('autodownloadAudio', event.value);
}

PrefsAssistant.prototype.autoVoiceNoteHandler = function(event){
    _depotDB.putPrefs('autodownloadVoiceNote', event.value);
}

PrefsAssistant.prototype.showOnlineHandler = function(event){
    _depotDB.putPrefs('showOnline', event.value);
    if (_chatsAssistant != null) {
        _chatsAssistant.updateChats();
    }
    if (_contactsAssistant != null) {
        _contactsAssistant.loadContacts();
    }
}


PrefsAssistant.prototype.cleanup = function(){
    _prefsAssistant = null;
    
    this.controller.stopListening('language', Mojo.Event.propertyChanged, this.languageHandler);
    this.controller.stopListening('personSoundSelector', Mojo.Event.propertyChanged, this.personSoundHandler);
    this.controller.stopListening('personVibrateToggle', Mojo.Event.propertyChanged, this.personVibrateHandler);
    this.controller.stopListening('groupSoundSelector', Mojo.Event.propertyChanged, this.groupSoundHandler);
    this.controller.stopListening('groupVibrateToggle', Mojo.Event.propertyChanged, this.groupVibrateHandler);
    this.controller.stopListening('groupBannerToggle', Mojo.Event.propertyChanged, this.groupBannerHandler);
    this.controller.stopListening('personBannerToggle', Mojo.Event.propertyChanged, this.personBannerHandler);
    this.controller.stopListening('personBlinkToggle', Mojo.Event.propertyChanged, this.personBlinkHandler);
    this.controller.stopListening('groupBlinkToggle', Mojo.Event.propertyChanged, this.groupBlinkHandler);
    this.controller.stopListening('bgTimeoutSelector', Mojo.Event.propertyChanged, this.bgTimeoutHandler);
    this.controller.stopListening('bgTimeoutSelector', Mojo.Event.propertyChanged, this.bgTimeoutHandler);
    this.controller.stopListening('personTonePathRow', Mojo.Event.tap, this.personTonePathTapHandler);
    this.controller.stopListening('groupTonePathRow', Mojo.Event.tap, this.groupTonePathTapHandler);
    this.controller.stopListening('chatTextSize', Mojo.Event.propertyChanged, this.chatTextSizeHandler);
    this.controller.stopListening('imageSize', Mojo.Event.propertyChanged, this.imageSizeHandler);
    this.controller.stopListening('phoneType', Mojo.Event.propertyChanged, this.phoneTypeHandler);
    this.controller.stopListening("profileImage", Mojo.Event.tap, this.profileImageHandler);
    this.controller.stopListening('bubbleclassSelector', Mojo.Event.propertyChanged, this.bubbleclassHandler);
    this.controller.stopListening('backimageSelector', Mojo.Event.propertyChanged, this.backimageHandler);
    this.controller.stopListening('backimagePathRow', Mojo.Event.tap, this.backimagePathTapHandler);
    this.controller.stopListening('closedashSelector', Mojo.Event.propertyChanged, this.closedashHandler);
    this.controller.stopListening('closenomessagesSelector', Mojo.Event.propertyChanged, this.closenomessagesHandler);
    this.controller.stopListening('autodownloadImage', Mojo.Event.propertyChanged, this.autoImageHandler);
    this.controller.stopListening('autodownloadVideo', Mojo.Event.propertyChanged, this.autoVideoHandler);
    this.controller.stopListening('autodownloadAudio', Mojo.Event.propertyChanged, this.autoAudioHandler);
    this.controller.stopListening('autodownloadVoiceNote', Mojo.Event.propertyChanged, this.autoVoiceNoteHandler);
    this.controller.stopListening('showOnline', Mojo.Event.propertyChanged, this.showOnlineHandler);
	this.controller.stopListening('invisibleMode', Mojo.Event.propertyChanged, this.invisibleModeHandler);
}
