var _displayOn = true;
var _activity_count = 0;
var _displayManagerRequest = null;
var _wanManagerRequest;
var _netManagerRequest = null;
var _powerManagerRequest;
var _timerManagerRequestSet;
var _timerManagerRequestClear;
var _systemPropertiesRequest;
var _iconChangeRequest;

function PalmServices(){
}

PalmServices.enableWanData = function(dataDisabled){
    _wanManagerRequest = new Mojo.Service.Request('palm://com.palm.wan', {
        method: 'set',
        parameters: {
            disablewan: dataDisabled
        }
    });
}

PalmServices.subscribeDisplayManager = function(){
    if (_displayManagerRequest == null) {
        _displayManagerRequest = new Mojo.Service.Request("palm://com.palm.display/control", {
            method: "status",
            parameters: {
                "subscribe": true
            },
            onSuccess: function(e){
                Mojo.Log.info("Status success, results=" + JSON.stringify(e));
                var changed = true;
                switch (e.event) {
                    case 'request':
                        (e.state == "on" ? _displayOn = true : _displayOn = false);
                        break;
                    case 'displayActive':
                        _displayOn = true;
                        break;
                    case 'displayDeactivate':
                    case 'displayInactive':
                        _displayOn = false;
                        break;
                    default:
                        changed = false;
                        break;
                }
                if (changed && (_chatsAssistant != null || _dashboardAssistant != null)) {
                    if (!_displayOn) {
                        if (_plugin != null && _dashboardAssistant == null) 
                            _plugin.sendActive(0);
                        PalmServices.setWakeUpAlarmBG();
                    }
                    else {
                        PalmServices.clearWakeUpAlarmBG();
                        if (_plugin != null) {
                            _mojowhatsupPlugin.safePluginCall(function(){
                                if (_dashboardAssistant == null) 
                                    _plugin.sendActive(1);
                                _plugin.closeConnection();
                            });
                        }
                    }
                }
            }
.bind(this)            ,
            onFailure: function(e){
                Mojo.Log.info("Status failure, results=" + JSON.stringify(e));
            }
        });
    }
}

PalmServices.subscribeNetworkStatus = function(){
    if (_netManagerRequest != null) 
        delete _netManagerRequest;
    
    _netManagerRequest = new Mojo.Service.Request('palm://com.palm.connectionmanager', {
        method: 'getstatus',
        parameters: {
            subscribe: true
        },
        onSuccess: function(response){
            Mojo.Log.info("Network Manager Response %j", response);
            if (response.isInternetConnectionAvailable) {
                if (!_networkConnected) {
                    _networkConnected = true;
                    if (_plugin != null) {
                        _mojowhatsupPlugin.safePluginCall(function(){
                            _plugin.networkStatusChanged(1);
                            //                        if (_dashboardAssistant != null) {
                            //                            // setTimeout(function() {
                            //                            // _plugin.sendActive(0);
                            //                            // }, 10000);
                            //                            _dashboardAssistant.setBGTimeout();
                            //                        }
                        });
                    }
                }
            }
            else {
                Mojo.Log.info("Internet connection not available!");
                if (_networkConnected) {
                    _networkConnected = false;
                    if (_plugin != null) {
                        _mojowhatsupPlugin.safePluginCall(function(){
                            _plugin.networkStatusChanged(0);
                        });
                        
                        if (_appAssistant != null || _dashboardAssistant != null) 
                            PalmServices.clearWakeUpAlarmBG();
                        //						if (_dashboardAssistant != null) {
                        //							_dashboardAssistant.clearBGTimeout();
                        //						}
                    }
                }
            }
        }
.bind(this)        ,
        onFailure: function(response){
            Mojo.Log.info("Connection Status Service Request FAILED!");
        }
.bind(this)
    });
}

PalmServices.setActivity = function(duration){
    Mojo.Log.info("Called setActivity %d mills.", duration);
    _activity_count++;
    _powerManagerRequest = new Mojo.Service.Request("palm://com.palm.power/com/palm/power", {
        method: "activityStart",
        parameters: {
            id: "com.palm.mojowhatsup.alive-" + _activity_count,
            duration_ms: duration
        },
        onSuccess: function(response){
            Mojo.Log.info("Power Manager Response: activityStart: %j", response);
        },
        onFailure: function(response){
            Mojo.Log.info("Power Manager Service Request:activityStart FAILED!");
        }
    });
}

PalmServices.clearActivity = function(){
    _powerManagerRequest = new Mojo.Service.Request("palm://com.palm.power/com/palm/power", {
        method: "activityEnd",
        parameters: {
            id: "com.palm.mojowhatsup.alive-" + _activity_count
        },
        onSuccess: function(response){
            Mojo.Log.info("Power Manager Response: activityEnd: %j", response);
        },
        onFailure: function(response){
            Mojo.Log.info("Power Manager Service Request:activityEnd FAILED!");
        }
    });
}

PalmServices.setWakeUpAlarm = function(){
    Mojo.Log.info("Setting wake up alarm!");
    _timerManagerRequestSet = new Mojo.Service.Request('palm://com.palm.power/timeout', {
        method: "set",
        parameters: {
            "key": "mojoWhatsupTimeoutFG",
            "in": "00:10:00",
            "wakeup": true,
            "uri": "palm://com.palm.applicationManager/open",
            "params": "{'id':'com.palm.mojowhatsup','params':{'action': 'timeout', 'type': 'foreground'}}"
        }
    });
}

PalmServices.setWakeUpAlarmBG = function(){
    Mojo.Log.info("Called setWakeUpAlarmBG");
    _timerManagerRequestSet = new Mojo.Service.Request('palm://com.palm.power/timeout', {
        method: "set",
        parameters: {
            "key": "mojoWhatsupTimeoutBG",
            "in": _depotDB.prefs.backgroundTimeout,
            "wakeup": true,
            "uri": "palm://com.palm.applicationManager/open",
            "params": "{'id':'com.palm.mojowhatsup','params':{'action': 'timeout', 'type': 'background'}}"
        }
    });
}

PalmServices.clearWakeUpAlarm = function(){
    Mojo.Log.info("Clearing wake up alarm!");
    _timerManagerRequestClear = new Mojo.Service.Request('palm://com.palm.power/timeout', {
        method: "clear",
        parameters: {
            "key": "mojoWhatsupTimeoutFG"
        }
    });
}

PalmServices.clearWakeUpAlarmBG = function(){
    Mojo.Log.info("Called clearWakeUpAlarmBG");
    _timerManagerRequestClear = new Mojo.Service.Request('palm://com.palm.power/timeout', {
        method: "clear",
        parameters: {
            "key": "mojoWhatsupTimeoutBG"
        }
    });
}

PalmServices.setIconNoMessages = function(){
    var iconUrl = Mojo.appPath + 'images/' + 'mojowhatsupgray64.png';
    _iconChangeRequest = new Mojo.Service.Request('palm://com.palm.applicationManager', {
        method: 'updateLaunchPointIcon',
        parameters: {
            launchPointId: 'com.palm.mojowhatsup_default',
            icon: iconUrl
        }
    });
}

PalmServices.setIconMessages = function(){
    var iconUrl = Mojo.appPath + 'images/' + 'mojowhatsup64.png';
    _iconChangeRequest = new Mojo.Service.Request('palm://com.palm.applicationManager', {
        method: 'updateLaunchPointIcon',
        parameters: {
            launchPointId: 'com.palm.mojowhatsup_default',
            icon: iconUrl
        }
    });
}

